from collections import deque

def main():
    n = int(input())
    gr = [[] for i in range(n)]
    for i in range(n - 1):
        u, v = map(int, input().split())
        u -= 1
        v -= 1
        gr[u].append(v)
        gr[v].append(u)

    dp = [0] * n
    par = [-1] * n
    h = [0] * n
    q = deque()
    q.append(0)
    par[0] = 0
    order = []
    order.append(0)

    while len(q) > 0:
        u = q.popleft()
        for v in gr[u]:
            if par[v] == -1:
                par[v] = u
                h[v] = h[u] + 1
                q.append(v)
                order.append(v)

    depth = [n] * n
    for u in reversed(order):
        sm = 0
        for v in gr[u]:
            if v != par[u]:
                depth[u] = min(depth[u], depth[v] + 1)
                sm += dp[v]
        if depth[u] == n:
            depth[u] = 0

        if depth[u] <= h[u]:
            dp[u] = 1
        else:
            dp[u] = sm

    print(dp[0])

main()
