#include "testlib.h"
using namespace std;
const int MAX_OUTER = 1e9;
const int MAX_INNER = 3e5;
const string RANDOM = "random";
const string MAX = "max";
int main(int argc, char** argv)
{
	registerGen(argc, argv, 1);
	if (argv[1] == RANDOM || argv[1] == MAX)
	{
		const int MAX_OUTER = max(1, atoi(argv[2]));
		const int MAX_INNER = max(1, min(MAX_OUTER, atoi(argv[3])));
		int H, W, h, w;
		if (argv[1] == RANDOM)
		{
			do
			{
				H = rnd.next(1, MAX_OUTER);
				h = rnd.next(1, MAX_INNER);
			} while (h > H);
			do
			{
				W = rnd.next(1, MAX_OUTER);
				w = rnd.next(1, MAX_INNER);
			} while (w > W);
		}
		else
		{
			H = W = MAX_OUTER;
			h = w = MAX_INNER;
		}
		cout << H << ' ' << W << '\n' << h << ' ' << w << '\n';
	}
	else
		quitf(_fail, "unknown test type: \"%s\"", argv[1]);
}