#include <iostream>
#include <vector>
#include <unordered_set>

int main() {

    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);

    unsigned int n, q;
    std::cin >> n >> q;

    std::vector<unsigned int> roles(n);
    unsigned int director = 0;
    for (unsigned int i = 0; i < n; i++) {
        std::cin >> roles[i];
        if (roles[i] == 0) {
            director = i;
        }
    }

    std::vector<std::unordered_set<unsigned int>> unread(n);

    for (unsigned int i = 0; i < q; i++) {
        unsigned int cmd, a;
        std::cin >> cmd >> a;
        a--;

        if (cmd == 1) {
            unsigned int b;
            std::cin >> b;
            b--;

            unread[b].insert(i);
            if (roles[a] == 1 && roles[b] == 2) {
                unread[director].insert(i);
            } else if (roles[a] == 2 && roles[b] == 1) {
                for (unsigned int t = 0; t < n; t++) {
                    if (roles[t] != 2) {
                        unread[t].insert(i);
                    }
                }
            }
        } else if (cmd == 2) {
            unsigned int x;
            std::cin >> x;
            x--;

            unread[a].erase(x);
            if (roles[a] == 1) {
                for (unsigned int t = 0; t < n; t++) {
                    if (roles[t] == 1) {
                        unread[t].erase(x);
                    }
                }
            }
        } else {
            std::cout << unread[a].size() << '\n';
        }
    }

}