//#define LOCAL

#include <iostream>
#include <unordered_set>
#include <vector>
#include <string>
#include <cstdlib>
#include <cstdio>
#include <random>
#ifdef LOCAL
#include "../testlib.h"
#else
#include "testlib.h"
#endif
int next;
std::vector<int> times;

std::string to_mm_and_ss(int t) {
    int minutes = t / 60;
    int seconds = t % 60;
    return std::to_string(minutes / 10) + std::to_string(minutes % 10) + ":" +
        std::to_string(seconds / 10) + std::to_string(seconds % 10);
}
int main(int argc, char *argv[]) {
    registerGen(argc, argv, 1);
    int n = atoi(argv[1]);
    if (n == 0) {
        n = rnd.next(1, 1000);
    }
    std::cout << n << std::endl;
    int max_seconds = (23 * 60 * 60 + 59 * 60 + 59);
    int seed = max_seconds / n;
    int max_song_time = (59 * 60 + 59);
    times.resize(n);
    max_seconds -= n;
    max_seconds -= rnd.next(0, max_seconds);
    for (int i = 0; i < times.size(); ++i) {
        times[i] = 1;
        next = rnd.next(0, std::min(seed, std::min(max_seconds, max_song_time)));
        times[i] += next;
        max_seconds -= next;
    }
    auto rng = std::default_random_engine {};
    std::shuffle(std::begin(times), std::end(times), rng);
    // std::random_shuffle(times.begin(), times.end());
    for (int i = 0; i < times.size(); ++i) {
        std::cout << to_mm_and_ss(times[i]) << std::endl;
    }
    return 0;
}