#include "testlib.h"
#include <vector>

using namespace std;

long long gcd(long long a, long long b) {
    return a == 0 || b == 0 ? a + b : gcd(b % a, a);
}

const int limit = 1000000000;

int main(int argc, char *argv[]) {
    registerGen(argc, argv, 1);

    int n = atoi(argv[1]);
    if (argc > 2) {
        int m = atoi(argv[2]);
        println(n, m);
    } else {
        int x = rnd.next(1, min(limit / n, n));
        int y = rnd.next(1, min(limit / n, n));
        while (gcd(x, y) > 1) {
            y = rnd.next(1, min(limit / n, n));
        }
        println(n * x, n * y);
    }
}