#include <bits/stdc++.h>
using namespace std;

struct points {
    long long x, y;

    points() : x(0), y(0) {}

    points(long long x, long long y) : x(x), y(y) {}
};

struct rectangle {
    points le, ri;

    rectangle(points le, points ri) : le(le), ri(ri) {}


};

rectangle intersection(rectangle& fi, rectangle& sec) {
    points left_points(max(fi.le.x, sec.le.x), max(fi.le.y, sec.le.y));
    points right_points(min(fi.ri.x, sec.ri.x), min(fi.ri.y, sec.ri.y));
    return {left_points, right_points};
}

int n;
vector<points> robots;

bool beda(rectangle& rect) {
    return rect.le.x > rect.ri.x || rect.le.y > rect.ri.y;
}

int main() {
    cin >> n;
    for (int i = 0; i < n; i++) {
        long long a, b;
        cin >> a >> b;
        robots.push_back({a, b});
    }
    long long l = -1;
    long long r = 2ll * 1e18 + 4ll;
    while (l < r - 1) {
        long long m = (l + r) / 2;
        points point1(robots[0].x - robots[0].y + m, robots[0].x + robots[0].y + m);
        points point2(robots[0].x - robots[0].y - m, robots[0].x + robots[0].y - m);
        rectangle now_rect(point2, point1);
        bool flag = false;
        for (int i = 1; i < n; i++) {
            points point3 = points(robots[i].x - robots[i].y + m, robots[i].x + robots[i].y + m);
            points point4 = points(robots[i].x - robots[i].y - m, robots[i].x + robots[i].y - m);
            rectangle next_rect(point4, point3);
            now_rect = intersection(now_rect, next_rect);
            if (beda(now_rect)) {
                l = m;
                flag = true;
                break;
            }
        }
        if (!flag) {
            r = m;
        }
    }
    cout << r << endl;
    return 0;
}
// 1000000000000000000