// Generator created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include "testlib.h"
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;


int main(int argc, char* argv[]) {
	registerGen(argc, argv, 1);

	int n = opt<int>(1);
	int sz = opt<int>(2);
	int percent = opt<int>(3);

	vector<int> perm(n);
	iota(perm.begin(), perm.end(), 0);
	shuffle(perm.begin(), perm.end());

	set<pii> edges;
	for (int i = 0; i < n; ++i) {
		for (int j = max(i + 1, sz); j < n; ++j) {
			if (rnd.next() < percent / 100.0) {
				int a = perm[i], b = perm[j];
				if (a > b) {
					swap(a, b);
				}
				edges.insert({a, b});
			}
		}
	}

	for (int i = 0; i < n - 1; ++i) {
		int j = i + 1;
		if (edges.count({i, j})) {
			edges.erase({i, j});
		} else {
			edges.insert({i, j});
		}
	}

	vector<pii> arr_edges(edges.begin(), edges.end());
	shuffle(arr_edges.begin(), arr_edges.end());

	cout << n << " " << szof(arr_edges) << "\n";
	for (auto e : arr_edges) {
		if (rnd.next(0, 1)) {
			swap(e.ff, e.ss);
		}
		cout << e.ff + 1 << " " << e.ss + 1 << "\n";
	}

	return 0;
}