#include <iostream>
using namespace std;
typedef long long ll;
const int M = 1000000007;
int prod(const int x, const int y)
{
	return ((ll)x) * y % M;
}
int sum(const int x, const int y)
{
	int z = x + y;
	if (z >= M)
		z -= M;
	return z;
}
int dif(const int x, const int y)
{
	int z = x - y;
	if (z < 0)
		z += M;
	return z;
}
int inv(const int x, const int m = M)
{
	return (x == 1 ? 1 : (1 - inv(m % x, x) * ((ll)m)) / x + m);
}
int inter(const int H, const int h)
{
	int ans = (((ll) h) * (h + 1) / 2) % M;
	ans = prod(ans, ans);
	for (int s = 2; s <= min(2 * h, H); ++s)
	{
		int addition = prod(min(s - 1, 2 * h + 1 - s), prod(s - 1, dif(H + 1, s)));
		ans = sum(ans, addition);
	}
	for (int s = H + 1; s <= 2 * h; ++s)
	{
		int addition = prod(2 * h + 1 - s, prod(H + 1, dif(H + 1, s)));
		ans = sum(ans, addition);
	}
	return ans;
}
int all(const int H, const int h)
{
	return prod(prod(sum(dif(prod(2, H), h), 1), h), inv(2));
}
int main()
{
	int H, W, h, w;
	cin >> H >> W >> h >> w;
	int all_one = prod(all(H, h), all(W, w));
	cout << dif(prod(all_one, all_one), prod(inter(H, h), inter(W, w))) << '\n';
}