#include <iostream>
#include <algorithm>
using namespace std;
typedef long long ll;
const int M = 1000000007;
int prod(const int x, const int y)
{
	return ((ll)x) * y % M;
}
void dec(int& x, const int y = 1)
{
	x -= y;
	if (x < 0)
		x += M;
}
void inc(int& x, const int y = 1)
{
	x += y;
	if (x >= M)
		x -= M;
}
int dif(int x, int y)
{
	dec(x, y);
	return x;
}
int main()
{
	int H, W, h, w;
	cin >> H >> W >> h >> w;
	int ansH = (2ll * H - h + 1) * h / 2;
	int ansW = (2ll * W - w + 1) * w / 2;
	int ans_temp = prod(ansH, ansW);
	int ans = prod(ans_temp, ans_temp);
	for (int h1l = 0; h1l < H; ++h1l)
		for (int h1u = h1l + 1; h1u <= min(h1l + h, H); ++h1u)
			for (int w1l = 0; w1l < W; ++w1l)
				for (int w1r = w1l + 1; w1r <= min(w1l + w, W); ++w1r)
				{
					int decH = 0;
					for (int h2l = max(0, h1l - h + 1); h2l < h1l; ++h2l)
						inc(decH, dif(min(h2l + h, H), h1l));
					for (int h2l = h1l; h2l < h1u; ++h2l)
						inc(decH, dif(min(h2l + h, H), h2l));
					int decW = 0;
					for (int w2l = max(0, w1l - w + 1); w2l < w1l; ++w2l)
						inc(decW, dif(min(w2l + w, W), w1l));
					for (int w2l = w1l; w2l < w1r; ++w2l)
						inc(decW, dif(min(w2l + w, W), w2l));
					dec(ans, prod(decH, decW));
				}
	cout << ans << '\n';
}