#include <iostream>
#include <vector>
#include <unordered_set>

int main() {

    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);

    unsigned int n, q;
    std::cin >> n >> q;

    std::vector<unsigned int> roles(n);
    unsigned int director = 0;
    for (unsigned int i = 0; i < n; i++) {
        std::cin >> roles[i];
        if (roles[i] == 0) {
            director = i;
        }
    }

    std::unordered_set<unsigned int> teachers_common;
    std::vector<std::unordered_set<unsigned int>> unread(n);

    for (unsigned int i = 0; i < q; i++) {
        unsigned int cmd, a;
        std::cin >> cmd >> a;
        a--;

        if (cmd == 1) {
            unsigned int b;
            std::cin >> b;
            b--;

            if (roles[a] == 0) {
                unread[b].insert(i);
            } else if (roles[a] == 1) {
                unread[b].insert(i);
                if (roles[b] == 2) {
                    unread[director].insert(i);
                }
            } else {
                if (roles[b] == 1) {
                    teachers_common.insert(i);
                    unread[director].insert(i);
                } else {
                    unread[b].insert(i);
                }
            }
        } else if (cmd == 2) {
            unsigned int x;
            std::cin >> x;
            x--;

            if (roles[a] == 1 && teachers_common.count(x) > 0) {
                teachers_common.erase(x);
            } else {
                unread[a].erase(x);
            }
        } else {
            std::cout << unread[a].size() + (roles[a] == 1 ? teachers_common.size() : 0) << '\n';
        }
    }

}