#include "testlib.h"
using namespace std;
int main(int argc, char* argv[])
{
	registerGen(argc, argv, 1);
	string type = argv[1];
	const int MAX_M = atoi(argv[2]);
	int M = rnd.next(2, MAX_M), A = 1, B = 1;
	if (type == "up")
	{
		while (A >= B)
		{
			A = rnd.next(1, M);
			B = rnd.next(1, M);
		}
	}
	else if (type == "down")
	{
		while (A <= B)
		{
			A = rnd.next(1, M);
			B = rnd.next(1, M);
		}
	}
	else if (type == "equal")
	{
		A = rnd.next(1, M);
		B = A;
	}
	else if (type == "one-up")
	{
		A = rnd.next(1, M - 1);
		B = A + 1;
	}
	else if (type == "one-down")
	{
		A = rnd.next(2, M);
		B = A - 1;
	}
	else
		quitf(_fail, "unknown test type: \"%s\"", type.c_str());
	cout << M << '\n' << A << '\n' << B << '\n';
}